Page MenuHomePhabricator

List Git/Gerrit repositories with 'worst' performance on unreviewed (CR0) changesets / changesets waiting for merge (CR1)
Open, LowPublic

Description

http://korma.wmflabs.org/browser/gerrit_review_queue.html offers a ranking of repositories; sorted by oldest median age of unreviewed changesets:

In T132421 we decided that we would like to keep such a ranking, however (question:) we'd first like to know how much work/hours it would take to implement this for either Gerrit or Differential or both (keeping in mind that Gerrit will get replaced by Differential; see T118753).

(Notes for myself only:

  • Currently korma's gerrit_review_queue.html unfortunately does not exclude all of "Status = Merge Conflict" or V = -1 or CR = -1 or CR = -2 in Gerrit
  • Once available in some form, create task to about think how to filter between repositories deployed on WMF sites vs not deployed on WMF sites)

Event Timeline

Aklapper updated the task description. (Show Details)Nov 24 2016, 1:41 PM
Aklapper triaged this task as Low priority.Jan 27 2017, 10:14 PM
hashar removed a subscriber: hashar.Aug 20 2018, 9:28 AM
Aklapper added a comment.EditedDec 14 2018, 8:50 PM

Assuming "unreviewed" means CR0 and not only "NEW" (which can mean CR-2, CR-1, CR+1 in contrast to ABANDONED and MERGED), this is currently blocked on https://github.com/chaoss/grimoirelab/issues/96

Aklapper added a comment.EditedJan 13 2019, 10:45 PM

We have this data now on https://wikimedia.biterg.io under "Gerrit > Efficiency" in the "Repositories" widget. It shows "Median Time Open (Days)" per repository and you can sort by that by clicking the column header. Note that you must first set the time span in the upper right corner to something like "Relative: 10 years ago" to have it cover all open changesets in Gerrit. (The "Median Time Open" value will always be lower than the time span set.)

However that Median Time Open value ignores the CR status or Merge Conflicts, so even a CR-2'ed changeset is included in the "Median Time Open (Days)" value. This would require https://github.com/chaoss/grimoirelab/issues/96 to get fixed.

Obviously this does not take into account the number of open patchsets, so if there is a repo with only one open patchset 5 years old and all other patchsets merged, while another repo has all 3-5 year old patchsets open and zero patchsets merged, the latter looks better.

Aklapper renamed this task from Provide equivalent of korma's "Gerrit review queue" (listing the 'worst' SCR repositories) in Kibana to List Git/Gerrit repositories with 'worst' performance on unreviewed (CR0) changesets / changesets waiting for merge (CR1).May 10 2019, 4:53 PM

Wondering if on "Gerrit Timing", "Avg. Time Open (Days)" should not only be offered for Submitters but also Repositories. It's a bit of duplication but also more consistent.